clear all
clc % tuning of the parameters using symmetrical optimum method
ki=100;
kp=1;
zeta=0.032;
khi=1;
prompt = 'What is R?'; %resonant controller gain (20 is being used)
R= input(prompt);
R
prompt = 'What is L?'; %resonant controller gain (20 is being used)
L= input(prompt);L
wcHPF=0;
Rc=2e-1/0.3187;
C=0.3187*990e-6;%capacitance of the filter
Td=180e-6;%time delay for the reference current
w=2*pi*50;
wc=zeta*w;% zeta is the damping ratio being used
h0=tf([kp 2*wc*(ki+kp) (kp*w*w)],[1 2*wc w*w]);% it is the non ideal PR controller function
h0
Gpnonidealharmonics=tf([kp 2*wc*(kp+ki) kp*w*w],[1 2*wc w*w]);% it is the non ideal PR controller function%Gf
Gpnonidealharmonics
Ind=tf([L 0],[1]);
Ind
Gdelay=tf(1,[Td 1]);% it is the delay function
Gdelay
Zc=(Rc+tf(1,[C 0]));%it is the capacitive impedance
Zc
den=(1+(h0*Zc*Gdelay));
den
Zo=Zc/den;
A=Zo*h0*Gdelay;
A
ZoR=((A*R)+Zo+(A*Ind));
ZoR
bode((ZoR),{10,1e6});
grid;
title('new output impedance with a virtual impedance added ');
figure;
bode(h0/(1+h0),{10,1e6});
grid;
title('Closed Loop PR Transfer Function ');



